package com.ruoyi.gysl.controller;


import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.gysl.entity.Mx;
import com.ruoyi.gysl.entity.request.MxRequest;
import com.ruoyi.gysl.entity.request.XmzskPageReq;
import com.ruoyi.gysl.entity.request.YsUpdateReq;
import com.ruoyi.gysl.service.MxService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;
import java.io.Serializable;
import java.util.List;

/**
 * 模型管理(Mx)表控制层
 *
 * @author makejava
 * @since 2025-02-24 13:40:34
 */
@Api(tags = "模型管理")
@RestController
@RequestMapping("/gysl/mx")
public class MxController extends BaseController {


    /**
     * 服务对象
     */
    @Resource
    private MxService mxService;

    /**
     * 查询所有模型数据
     *
     * @return 所有数据
     */
    @GetMapping("/page")
    @ApiOperation("查询所有模型数据")
    public AjaxResult selectAll(MxRequest mxRequest) {
        return success(mxService.selectAll(mxRequest));
    }
    /**
     * 通过主键查询单条数据
     *
     * @param id 主键
     * @return 单条数据
     */
    @GetMapping("/{id}")
    @ApiOperation(value = "通过主键查询单条数据",response = Mx.class)
    public AjaxResult selectOne(@PathVariable Serializable id) {
        return success(mxService.getById(id));
    }


    /**
     * 新增指标数据
     *
     * @param mx 实体对象
     * @return 新增结果
     */
    @PostMapping("/add")
    @ApiOperation("新增指标数据")
    public AjaxResult insertZb(@RequestBody Mx mx) {
        return success(mxService.add(mx));
    }


    /**
     * 修改要素
     *
     * @param mx 实体对象
     * @return 修改结果
     */
    @PostMapping("/updateYs")
    @ApiOperation("修改要素")
    public AjaxResult updateYs(@RequestBody YsUpdateReq mx) {
        return success(mxService.updateYs(mx));
    }

    /**
     * 修改指标
     *
     * @param mx 实体对象
     * @return 修改结果
     */
    @PostMapping("/edit")
    @ApiOperation("修改指标")
    public AjaxResult update(@RequestBody Mx mx) {
        return success(mxService.updateById(mx));
    }

    /**
     * 删除指标
     *
     * @param idList 主键结合
     * @return 删除结果
     */
    @ApiOperation("删除指标")
    @DeleteMapping("/delete")
    public AjaxResult delete(@RequestParam("idList") List<Long> idList) {
        return success(mxService.removeByIds(idList));
    }

    /**
     * 删除要素
     */
    @ApiOperation("删除要素")
    @DeleteMapping("/deleteYs")
    public AjaxResult deleteYs(@Valid XmzskPageReq req) {
        return success(mxService.deleteYs(req));
    }
}

